using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;
using DirectX.Capture;

namespace CaptureTest
{

	/// <summary>
	/// Summary description for QuickTest.
	/// </summary>
	public class QuickTest : System.Windows.Forms.Form
	{

		[DllImport("user32.dll")]
		protected static extern int GetWindowLong(System.IntPtr hWnd, int nIndex);

		[DllImport("user32.dll")]
		protected static extern int SetWindowLong(System.IntPtr hWnd, int nIndex, int dwNewLong);
		
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Panel panelVideo;
		private Capture capture;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;

		public QuickTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			timer1.Enabled = true;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.button1 = new System.Windows.Forms.Button();
			this.panelVideo = new System.Windows.Forms.Panel();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button1.Location = new System.Drawing.Point(16, 328);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(160, 40);
			this.button1.TabIndex = 0;
			this.button1.Text = "Create/Recreate Preview";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// panelVideo
			// 
			this.panelVideo.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panelVideo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panelVideo.Location = new System.Drawing.Point(16, 16);
			this.panelVideo.Name = "panelVideo";
			this.panelVideo.Size = new System.Drawing.Size(448, 304);
			this.panelVideo.TabIndex = 7;
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button2.Location = new System.Drawing.Point(184, 328);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(136, 40);
			this.button2.TabIndex = 8;
			this.button2.Text = "Destroy Preview";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button3.Location = new System.Drawing.Point(24, 400);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(80, 24);
			this.button3.TabIndex = 9;
			this.button3.Text = "TV Tuner";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button4.Location = new System.Drawing.Point(112, 400);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 24);
			this.button4.TabIndex = 10;
			this.button4.Text = "SVideo";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// timer1
			// 
			this.timer1.Interval = 1;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// QuickTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 461);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.panelVideo);
			this.Controls.Add(this.button1);
			this.Name = "QuickTest";
			this.Opacity = 0;
			this.Text = "QuickTest";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			button2_Click(null, null);
			if ( capture == null )
			{
				Filters filters = new Filters();
				capture = new Capture( filters.VideoInputDevices[0], null );
			}
			else
			{
				capture.PreviewWindow = null;
				capture.Stop();
			}
			capture.VideoSource = capture.VideoSources[0];
			capture.PreviewFrameSize = new Size( 720, 480 );
			capture.Tuner.Channel = 9;
			capture.PreviewWindow = panelVideo;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			if ( capture != null )
			{
				capture.PreviewWindow = null;
				capture.Stop();
				capture.Dispose();
				capture = null;
			}
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			if ( capture != null )
			{
				capture.VideoSource = capture.VideoSources[0];
			}

		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			if ( capture != null )
			{
				capture.VideoSource = capture.VideoSources[1];
			}
		}

	
		// Timer1 has interval = 1. The timer is enabled
		// at the end of the form constructor.
		private void timer1_Tick(object sender, System.EventArgs e)
		{
			const int GWL_EXSTYLE = -20;
			const int WS_EX_LAYERED = 0x00080000;

			int n;

			timer1.Enabled = false;

			// Make the form fully opaque before changing the window style
			this.Opacity = 1;

			// Get the current window style
			n = GetWindowLong( this.Handle, GWL_EXSTYLE );

			// Clear the WS_EX_LAYERED flag
			n = n & (~WS_EX_LAYERED);

			// Save the changes to the window
			//SetWindowLong( this.Handle, GWL_EXSTYLE, n );
		}
	}
}
